package vcvlcbundletest;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.FlowLayout;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;

import de.clab.osami.conferencing.vlc.ServiceInterfaces.VcConfig;
import de.clab.osami.conferencing.vlc.ServiceInterfaces.VcControl;


public class VcGui implements ActionListener{

		JFrame frame;
		JButton button;
		VcControl vcControl;
		VcConfig vcConfig;
		Canvas remoteSurface, localSurface;
		Panel configPanel;
		
		public VcGui(VcControl vcc)
		{
			this.vcControl = vcc;
			vcConfig = (VcConfig) vcControl;
			
			remoteSurface = (Canvas) vcConfig.getVideoRemoteComponent();
			localSurface = (Canvas) vcConfig.getVideoLocalComponent();
			Panel videoPanel = new Panel();
			videoPanel.setLayout(new FlowLayout());
			videoPanel.add(localSurface);
			videoPanel.add(remoteSurface);
			
			this.configPanel = vcConfig.getConfigurationPanel();
			
			frame = new JFrame("Videoconferencing test");
			
			button = new JButton("Start");
			button.addActionListener(this);
			Panel buttonPanel = new Panel();
			buttonPanel.add(button);
			
			frame.setLayout(new BorderLayout());
			frame.add(buttonPanel,BorderLayout.SOUTH);
			frame.add(configPanel,BorderLayout.CENTER);
			frame.add(videoPanel,BorderLayout.NORTH);

			frame.pack();
			frame.setVisible(true);
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					super.windowClosing(e);
					frame.dispose();
					vcControl.stop();
					System.exit(0);
				}
			});
			
			vcConfig = (VcConfig) vcControl;
			

		}
	

		@Override
		public void actionPerformed(ActionEvent e) {
			if(e.getSource() instanceof JButton)
			{
				if(button.getText().equals("Start"))
				{
					vcConfig.reconfigure();
					vcControl.start();
					button.setText("Stop");
				}
				else
				{
					button.setText("Start");
					vcControl.stop();
				}
			}
			
		}
}
