package de.clab.osami.conferencing.vlc.activator;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

import uk.co.caprica.vlcj.log.Logger;
import uk.co.caprica.vlcj.version.LibVlcVersion;
import uk.co.caprica.vlcj.version.Version;

import de.clab.osami.conferencing.vlc.ServiceInterfaces.IVideoConference;
import de.clab.osami.conferencing.vlc.ServiceInterfaces.VcControl;
import de.clab.osami.conferencing.vlc.conferencingSystem.ConferencingSystem;
import de.clab.osami.conferencing.vlc.conferencingSystem.IProcessor;
import de.clab.osami.conferencing.vlc.processor.VlcProcessor;


public class Activator implements BundleActivator {

	IProcessor processor;
	VcControl vcControl;
	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		
		Version libVlcVersion =  LibVlcVersion.getVersion();
		//Logger.setLevel(Logger.Level.NONE);
		if(libVlcVersion.major()>=1 && libVlcVersion.minor()>=1 && libVlcVersion.revision()>=4)
		{
			processor = new VlcProcessor();
			IVideoConference vc = new ConferencingSystem(processor);
			context.registerService(IVideoConference.class.getName(), vc, null);
		}
		else
		{
			System.err.println("WARNING:\n Couldn't initialize vlc. Ensure that vlc >= v1.1.4 is installed");
			//context.registerService(IVideoConference.class.getName(), null, null);
		}

		//new StorageManager();
	}

	/*
	 * (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
	}

}
