package de.clab.osami.conferencing.vlc.conferencingSystem;

import java.util.ArrayList;

import de.clab.osami.conferencing.vlc.config.IConfiguration;
import de.clab.osami.conferencing.vlc.config.IConfigurationChangeListener;

public interface IProcessor extends IConfigurationChangeListener{
	
	// the init method needs to be called first. works as constructor
	
	public String start();
	
	public String stop();
	
	public String validate();
	
	public Object getRemoteVisualComponent();
	
	public Object getLocalVisualComponent();
	
	public String setRemoteVisualComponent(Object component);
	
	public String setLocalVisualComponent(Object component);
	
	public String setConfiguration(IConfiguration config);
	
	public IConfiguration getConfiguration();
	
	public String autoConfig();
	
	public ArrayList<String> getAudioDevices();
	
	public ArrayList<String> getVideoDevices();
	
	public ArrayList<String> getAudioCodecs();
	
	public ArrayList<String> getVideoCodecs();
	
	public String init(IConfiguration config);

	public void configure();
}
