package de.clab.osami.conferencing.vlc.config;

import java.awt.Dimension;

public interface IConfiguration extends IObservable{

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioCaptureInfo#getCaching()
	 */
	public abstract int getAudioCaching();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioCaptureInfo#getDevice()
	 */
	public abstract String getAudioDevice();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioCaptureInfo#getProtocol()
	 */
	public abstract String getAudioProtocol();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioCaptureInfo#isEnabled()
	 */
	public abstract boolean isAudioEnabled();

	/**
	 * @param caching
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioCaptureInfo#setCaching(int)
	 */
	public abstract void setAudioCaching(int caching);

	/**
	 * @param device
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioCaptureInfo#setDevice(java.lang.String)
	 */
	public abstract void setAudioDevice(String device);

	/**
	 * @param enabled
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioCaptureInfo#setEnabled(boolean)
	 */
	public abstract void setAudioEnabled(boolean enabled);

	/**
	 * @param protocol
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioCaptureInfo#setProtocol(java.lang.String)
	 */
	public abstract void setAudioProtocol(String protocol);

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.Transcoding#getBitrate()
	 */
	public abstract int getAudioBitrate();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioTranscoding#getChannelSize()
	 */
	public abstract int getAudioChannelSize();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.Transcoding#getCodec()
	 */
	public abstract String getAudioCodec();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioTranscoding#getSampleRate()
	 */
	public abstract int getAudioSampleRate();

	/**
	 * @param bitrate
	 * @see de.clab.osami.conferencing.vlc.config.items.Transcoding#setBitrate(int)
	 */
	public abstract void setAudioBitrate(int bitrate);

	/**
	 * @param channelSize
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioTranscoding#setChannelSize(int)
	 */
	public abstract void setAudioChannelSize(int channelSize);

	/**
	 * @param codec
	 * @see de.clab.osami.conferencing.vlc.config.items.Transcoding#setCodec(java.lang.String)
	 */
	public abstract void setAudioCodec(String codec);

	/**
	 * @param sampleRate
	 * @see de.clab.osami.conferencing.vlc.config.items.AudioTranscoding#setSampleRate(int)
	 */
	public abstract void setAudioSampleRate(int sampleRate);

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#getCaching()
	 */
	public abstract int getStreamCaching();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#getIp()
	 */
	public abstract String getStreamIp();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#getLocalPort()
	 */
	public abstract int getStreamLocalPort();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#getProtocol()
	 */
	public abstract String getStreamProtocol();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#getTargetPort()
	 */
	public abstract int getStreamTargetPort();

	/**
	 * @param caching
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#setCaching(int)
	 */
	public abstract void setStreamCaching(int caching);

	/**
	 * @param ip
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#setIp(java.lang.String)
	 */
	public abstract void setStreamIp(String ip);

	/**
	 * @param port
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#setLocalPort(int)
	 */
	public abstract void setStreamLocalPort(int port);

	/**
	 * @param protocol
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#setProtocol(java.lang.String)
	 */
	public abstract void setStreamProtocol(String protocol);

	/**
	 * @param targetPort
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#setTargetPort(int)
	 */
	public abstract void setStreamTargetPort(int targetPort);

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoCaptureInfo#getCaching()
	 */
	public abstract int getVideoCaching();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoCaptureInfo#getDevice()
	 */
	public abstract String getVideoDevice();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoCaptureInfo#getProtocol()
	 */
	public abstract String getVideoProtocol();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoCaptureInfo#isEnabled()
	 */
	public abstract boolean isVideoEnabled();

	/**
	 * @param caching
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoCaptureInfo#setCaching(int)
	 */
	public abstract void setVideoCaching(int caching);

	/**
	 * @param device
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoCaptureInfo#setDevice(java.lang.String)
	 */
	public abstract void setVideoDevice(String device);

	/**
	 * @param enabled
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoCaptureInfo#setEnabled(boolean)
	 */
	public abstract void setVideoEnabled(boolean enabled);

	/**
	 * @param protocol
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoCaptureInfo#setProtocol(java.lang.String)
	 */
	public abstract void setVideoProtocol(String protocol);

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.Transcoding#getBitrate()
	 */
	public abstract int getVideoBitrate();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.Transcoding#getCodec()
	 */
	public abstract String getVideoCodec();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoTranscoding#getFrameRate()
	 */
	public abstract int getVideoFrameRate();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoTranscoding#getScale()
	 */
	public abstract float getVideoScale();

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoTranscoding#getSize()
	 */
	public abstract Dimension getVideoSize();

	/**
	 * @param bitrate
	 * @see de.clab.osami.conferencing.vlc.config.items.Transcoding#setBitrate(int)
	 */
	public abstract void setVideoBitrate(int bitrate);

	/**
	 * @param codec
	 * @see de.clab.osami.conferencing.vlc.config.items.Transcoding#setCodec(java.lang.String)
	 */
	public abstract void setVideoCodec(String codec);

	/**
	 * @param frameRate
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoTranscoding#setFrameRate(int)
	 */
	public abstract void setVideoFrameRate(int frameRate);

	/**
	 * @param scale
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoTranscoding#setScale(float)
	 */
	public abstract void setVideoScale(float scale);

	/**
	 * @param size
	 * @see de.clab.osami.conferencing.vlc.config.items.VideoTranscoding#setSize(java.awt.Dimension)
	 */
	public abstract void setVideoSize(Dimension size);

	public void transfereValues(IConfiguration config);

	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#getLocalIp()
	 */
	public String getLocalIp();

	/**
	 * @param localIp
	 * @see de.clab.osami.conferencing.vlc.config.items.StreamingInfo#setLocalIp(java.lang.String)
	 */
	public void setLocalIp(String localIp);
	
	public void setVideoRemoteEnabled(Boolean flag);
	
	public void setVideoLocalEnabled(Boolean flag);

	/**
	 * @return the videoRemoteEnabled
	 */
	public boolean isVideoRemoteEnabled();

	/**
	 * @return the videoLocalEnabled
	 */
	public boolean isVideoLocalEnabled();


}