package de.clab.osami.conferencing.vlc.config.items;

import org.apache.log4j.Logger;

public class AudioCaptureInfo {
	private CaptureInfo captureInfo;
	
	private final static Logger log = Logger.getLogger(AudioCaptureInfo.class);
	
	public AudioCaptureInfo()
	{
		captureInfo = new CaptureInfo();
		
	}
	/*
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.CaptureInfo#getCaching()
	 */
	public int getCaching() {
		return captureInfo.getCaching();
	}
	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.CaptureInfo#getDevice()
	 */
	public String getDevice() {
		return captureInfo.getDevice();
	}
	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.CaptureInfo#getProtocol()
	 */
	public String getProtocol() {
		return captureInfo.getProtocol();
	}
	/**
	 * @return
	 * @see de.clab.osami.conferencing.vlc.config.items.CaptureInfo#isEnabled()
	 */
	public boolean isEnabled() {
		return captureInfo.isEnabled();
	}
	/**
	 * @param caching
	 * @see de.clab.osami.conferencing.vlc.config.items.CaptureInfo#setCaching(int)
	 */
	public void setCaching(int caching) {
		captureInfo.setCaching(caching);
	
	}
	/**
	 * @param device
	 * @see de.clab.osami.conferencing.vlc.config.items.CaptureInfo#setDevice(java.lang.String)
	 */
	public void setDevice(String device) {
		captureInfo.setDevice(device);
		log.info("Audio device is "+device);
	}
	/**
	 * @param enabled
	 * @see de.clab.osami.conferencing.vlc.config.items.CaptureInfo#setEnabled(boolean)
	 */
	public void setEnabled(boolean enabled) {
		captureInfo.setEnabled(enabled);
		log.info("Audio capturing is set to"+enabled);
	}
	/**
	 * @param protocol
	 * @see de.clab.osami.conferencing.vlc.config.items.CaptureInfo#setProtocol(java.lang.String)
	 */
	public void setProtocol(String protocol) {
		captureInfo.setProtocol(protocol);
		log.info("Audio protocol is"+protocol);
	}
	
}
