package de.clab.osami.conferencing.vlc.config.items;

import org.apache.log4j.Logger;

public class StreamingInfo {
	private final static Logger log = Logger.getLogger( StreamingInfo.class );
	
	private String protocol;
	private String ip;
	private String localIp;
	private int localPort;
	private int targetPort;
	private int caching;
	
	public int getCaching() {
		return caching;
	}
	
	public void setCaching(int caching) {
		this.caching = caching;
		log.info("Transmission caching is set to "+caching);
	}
	
	
	public String getProtocol() {
		return protocol;
	}
	public void setProtocol(String protocol) {
		this.protocol = protocol;
		log.info("Protocol is set to "+protocol);
	
	}
	public String getIp() {
		return ip;
	}
	public void setIp(String ip) {
		this.ip = ip;
		log.info("Ip is set to "+ip);
	}
	public int getLocalPort() {
		return localPort;
	}
	public void setLocalPort(int port) {
		this.localPort = port;
		log.info("Port is set to "+port);
	}

	public int getTargetPort() {
		return targetPort;
	}

	public void setTargetPort(int targetPort) {
		this.targetPort = targetPort;
		//TODO: check: changing of target Port will not be logged
	}

	/**
	 * @return the localIp
	 */
	public String getLocalIp() {
		return localIp;
	}

	/**
	 * @param localIp the localIp to set
	 */
	public void setLocalIp(String localIp) {
		this.localIp = localIp;
	}

}
