package de.clab.osami.conferencing.vlc.processor;

public interface ICodecManager {

	/**
	 * @return all supported Audio Codecs
	 */
	public String[] getAvailableAudioCodecs();
	
	/**
	 * @return all supported Video Codecs
	 */
	public String[] getAvailableVideoCodecs();
	
	/**
	 * @param name Name of the audio codec
	 * @return codec or null if it is not found
	 */
	public String audioName2codec(String name);
	
	/**
	 * @param codec codec 
	 * @return name of the audio codec or null if it is not found
	 */
	public String audioCodec2Name(String codec);
	
	/**
	 * @param name Name of the video codec
	 * @return codec or null if it is not found
	 */
	public String videoName2codec(String name);
	
	/**
	 * @param codec codec
	 * @return name of the video codec or null if it is not found
	 */
	public String videoCodec2Name(String codec);

}
