package de.clab.osami.conferencing.vlc.processor;

import de.clab.osami.conferencing.vlc.config.IConfiguration;

/**
 * @author christian
 *
 */
abstract class IParameterExtractor {
	private IConfiguration config;
	IParameterExtractor(IConfiguration config)
	{
		this.config = config;
	}
	
	/**
	 * 
	 * @return String[] the server options
	 */
	abstract String[] getServerOptions();
	
	/**
	 * 
	 * @return String[] the client options
	 */
	abstract String[] getClientOptions();
 
	/**
	 * @return the client locator
	 */
	abstract String getClientLocator();
	
	/**
	 * @return the server locator
	 */
	abstract String getServerLocator();

	/**
	 * @return IConfiguration the configuration
	 */
	protected IConfiguration getConfig() {
		return config;
	}

	/**
	 * sets the configuration object that has to be extracted
	 * @param IConfiguration
	 */
	protected void setConfig(IConfiguration config) {
		this.config = config;
	}


	
}
