package de.clab.osami.conferencing.vlc.processor;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import org.apache.log4j.Logger;

import uk.co.caprica.vlcj.player.MediaPlayerEventListener;
import uk.co.caprica.vlcj.player.MediaPlayerFactory;
import uk.co.caprica.vlcj.player.embedded.EmbeddedMediaPlayer;

public class VlcPlayer {
		
	private Canvas videoCanvas;

	
	private MediaPlayerFactory factory;
	//TODO check listener
	private MediaPlayerEventListener playerListener;
	private EmbeddedMediaPlayer player;
	private Frame videoFrame;
	private final static Logger log = Logger.getLogger( VlcPlayer.class );
	public final static Dimension defaultSize = new Dimension(352,288);
	
	
	public VlcPlayer(String frameName)
	{
	//	LibX11.INSTANCE.XInitThreads();

		// initialize default canvas
		videoCanvas = new Canvas();
		videoCanvas.setBackground(Color.BLACK);
		videoCanvas.setSize(defaultSize);
		
		//initialize default frame
		videoFrame = new Frame(frameName);
		videoFrame.setLayout(new BorderLayout());
		videoFrame.pack();
		videoFrame.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e)
			{
				stop();
				
			}
		});
		
		//initialize player
		factory = new MediaPlayerFactory();

	    player = factory.newMediaPlayer(null);
		player.setVideoSurface(videoCanvas);
		
		
	}
	

	
	String start()
	{
		return start(true);
		
	}
	
	String start(boolean visible)
	{
		//check
		if(!videoCanvas.isDisplayable())
		{
			videoFrame.add(videoCanvas,BorderLayout.CENTER);
			videoFrame.pack(); //pack needs to be called
			videoFrame.setVisible(visible);
		}
		
		player.setVideoSurface(videoCanvas);
		try
		{
			player.play();
		}
		catch (Exception e) {
			return "Can't start vlc player. Check if its configured";
		}
	
		if(!player.isPlayable())
			return "vlc not configured";
		log.info("player is playable");
		return null;
	}
	
	void stop()
	{
		player.stop();
		if(videoFrame.isVisible())
		{
			videoFrame.setVisible(false);
		}
		videoFrame.removeAll();
	}
	
	void configure(String locator, String[] options, Dimension size)
	{
		videoCanvas.setSize(size);
		player.prepareMedia(locator, options);
	}
	
	void setCanvas(Canvas videoCanvas)
	{
		if(videoCanvas instanceof Canvas)
			this.videoCanvas = videoCanvas;
	}
	
	Canvas getCanvas()
	{
		return this.videoCanvas;
	}
	

	
	
    boolean isPlayable()
	{
    	boolean isPlayable=false;
    	
    	
    	start(false);
    	isPlayable = player.isPlayable();
    	stop();
    	
		return isPlayable;
		

	}
	
	
	
}
