package de.clab.osami.conferencing.vlc.test;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Panel;

import uk.co.caprica.vlcj.binding.LibX11;
import uk.co.caprica.vlcj.log.Log;
import uk.co.caprica.vlcj.player.MediaPlayer;
import uk.co.caprica.vlcj.player.MediaPlayerEventAdapter;
import uk.co.caprica.vlcj.player.MediaPlayerFactory;
import uk.co.caprica.vlcj.player.embedded.EmbeddedMediaPlayer;
import de.clab.osami.conferencing.vlc.util.Util;

public class Streaming {
	/**
	 * @param args
	 */
	static String vlc_args[] = {

//			"-vvv"
//		, "--ignore-config"
//            "-I", "dummy",
//            "v4l2:///dev/video0",
//            "--v4l2-caching", "100",
//            "--sout","'#transcode{vcodec=MJPG,vb=6000,fps=30,scale=1,width=352,height=288,acodec=none}:rtp{dst=131.234.51.2,port=5004,mux=ts}'"
             };
	
	public static void start(String[] args) {
		LibX11.INSTANCE.XInitThreads();
		String ip = Util.getLocalIp();
		
	    MediaPlayerFactory factory = new MediaPlayerFactory(vlc_args);
	    EmbeddedMediaPlayer mediaPlayer = factory.newMediaPlayer(null);
	    EmbeddedMediaPlayer localPlayer = factory.newMediaPlayer(null);
	    Log logger =factory.newLog();
	   
	  //  logger.
	    Frame frame= new Frame("Local video");
	    frame.setSize(352, 288);
	    
	    Canvas videoSurface = new Canvas();
	    videoSurface.setSize(new Dimension(352,288));
	    videoSurface.setBackground(Color.BLACK);

//	    frame.setLayout(new BorderLayout());
//	    frame.add(videoSurface,BorderLayout.CENTER);
	    
	    Panel videoPanel = new Panel();
	    videoPanel.setLayout(new BorderLayout());
	    videoPanel.add(videoSurface,BorderLayout.CENTER);
	    
	    frame.add(videoPanel);
	    frame.pack();
	    frame.setVisible(true);
	    mediaPlayer.setVideoSurface(videoSurface);
	    mediaPlayer.addMediaPlayerEventListener(new MediaPlayerEventAdapter() {
	      @Override
		public void finished(MediaPlayer mediaPlayer) {
	        System.exit(0);
	      }
	      @Override
		public void error(MediaPlayer mediaPlayer) {
	        System.exit(1);
	      }
	    });
	   // mediaPlayer.play();
	    mediaPlayer.prepareMedia("v4l2://",
	    						":input-slave=alsa://plughw:1,0",
	    						":v4l2-standard=0",
	    						":v4l2-caching=80"
	    						// MJPG
//	    						,":sout=#transcode{vcodec=MJPG,width=352,height=288,vb=2000,scale=1,acodec=none}:rtp{dst=131.234.51.2,port=5004,mux=ts}"
	    						//DIVX
	    						,":sout=#transcode{vcodec=DIV3,vb=800,fps=30,scale=1.0,width=352,height=288,acodec=mpga,ab=128,channels=2,samplerate=8000}:duplicate{dst=rtp{dst="+ip+",port=5004,mux=ts},dst=display}"
//	    						,"--sout-ts-dts-delay=0"
//	    						,"--sout-ts-shape-delay=0"
//	   							,"--no-sout-rtp-sap", 
//	   							"--no-sout-standard-sap", 
////	   						"--sout-all", 
//	   							"--sout-keep"
	    						);
	    

	    mediaPlayer.setContrast(100.0f);
	    System.out.println("Streamer: "+mediaPlayer);
	    System.out.println("AudioDelay:"+mediaPlayer.getAudioDelay());
	    System.out.println("VideoSize:"+mediaPlayer.getVideoDimension());
	    System.out.println(""+mediaPlayer.getFps());
	    System.out.println(mediaPlayer.getVideoDescriptions());
	    
	  //  localPlayer.playMedia("v4l2://");
	    

	    
	    mediaPlayer.play();
	    frame.pack();

	    
//	    try {
//			Thread.currentThread().join();
//		} catch (InterruptedException e) {
//			// 
//			e.printStackTrace();
//		}

	}

}
