package de.clab.osami.conferencing.vlc.ui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.GridLayout;
import java.awt.Panel;

import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.border.TitledBorder;

public class StreamingPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private JSpinner streamCachingSpinner;
	private JTextField streamIPTextField;
	private JComboBox streamProtocol;
	private JSpinner streamLocalPortSpinner;
	private JSpinner streamTargetPortSpinner;
	
	public StreamingPanel(Panel parent){

		parent.add(this,BorderLayout.CENTER);
		setLayout(new GridLayout(5,2,0,5));
		setBorder(new TitledBorder("Streaming"));
		
		streamCachingSpinner = new JSpinner(new SpinnerNumberModel(0,0,Integer.MAX_VALUE,1));
		addGUIElement("StreamCaching:"   ,streamCachingSpinner);
		
		streamIPTextField = new JTextField();
		addGUIElement("StreamIP:"        ,streamIPTextField);
		
		streamProtocol = new JComboBox(new String[]{"rtp"});
		addGUIElement("StreamProtocol:"  ,streamProtocol);
		
		streamLocalPortSpinner = new JSpinner(new SpinnerNumberModel(0,0,65535,1)); 
		addGUIElement("StreamLocalPort:" ,streamLocalPortSpinner);
		
		streamTargetPortSpinner = new JSpinner(new SpinnerNumberModel(0,0,65535,1));
		addGUIElement("StreamTargetPort:",streamTargetPortSpinner);
	}
	
	private void addGUIElement(String text, Component component){
		new GUIElement(this,text,component);
	}

	//GETTERs
	public JSpinner getStreamCachingSpinner() {
		return streamCachingSpinner;
	}

	public JTextField getStreamIPTextField() {
		return streamIPTextField;
	}

	public JComboBox getStreamProtocol() {
		return streamProtocol;
	}

	public JSpinner getStreamLocalPortSpinner() {
		return streamLocalPortSpinner;
	}

	public JSpinner getStreamTargetPortSpinner() {
		return streamTargetPortSpinner;
	}
}
